var DocumentationMenu;
(function (DocumentationMenu) {
    var NodeModel = /** @class */ (function () {
        function NodeModel(data) {
            var _this = this;
            this.isExpanded = ko.observable(false);
            this.isSelected = ko.observable(false);
            this.isPlaceholder = ko.observable(false);
            this.description = ko.observable('');
            this.name = ko.observable('');
            this.href = ko.observable('');
            this.nodes = ko.observable();
            this.headings = ko.observable();
            if (data == null)
                throw "null data";
            this.isExpanded(data.expanded);
            this.isSelected(data.selected);
            this.isPlaceholder(data.placeholder);
            this.description(data.description);
            this.name(data.name);
            this.href(data.href);
            this.nodeCssClass = ko.pureComputed(function () {
                return {
                    'minus-sign': _this.isExpanded() && _this.nodes().length > 0,
                    'plus-sign': !_this.isExpanded() && _this.nodes().length > 0,
                    'no-icon': _this.nodes().length === 0
                };
            });
            this.nodes(data.nodes.makeIterable().select(function (n) { return new NodeModel(n); }).toArray());
            this.headings(data.headings);
        }
        NodeModel.prototype.toggleVisibility = function () {
            if (this.nodes().length == 0)
                return this.visitLink();
            this.isExpanded(!this.isExpanded());
            return false;
        };
        ;
        NodeModel.prototype.visitLink = function () {
            window.location.href = this.href();
            return false;
        };
        return NodeModel;
    }());
    var TreeModel = /** @class */ (function () {
        function TreeModel(tree) {
            this.nodes = ko.observable();
            this.nodes(tree.nodes.makeIterable().select(function (n) { return new NodeModel(n); }).toArray());
        }
        return TreeModel;
    }());
    var PageModel = /** @class */ (function () {
        function PageModel(input) {
            this.tree = ko.observable();
            this.tree(new TreeModel(input.tree));
        }
        return PageModel;
    }());
    function Init() {
        $.ajax("/tree.json", {
            type: "GET",
            cache: false,
            contentType: "application/json",
            data: {
                path: window.location.pathname
            },
            success: function (d) {
                var model = new PageModel(d);
                var root = document.getElementById("nav-tree");
                ko.applyBindings(model, root);
            }
        });
    }
    DocumentationMenu.Init = Init;
})(DocumentationMenu || (DocumentationMenu = {}));
$(function () { return DocumentationMenu.Init(); });
//# sourceMappingURL=inedo_documentationmenu2.js.map